SystemOrganization addCategory: #ConfigurationOfXenon!

Object subclass: #ConfigurationOfXenon
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfXenon'!

!ConfigurationOfXenon commentStamp: '<historical>' prior: 0!
Gofer it 
      url: 'http://ss3.gemstone.com/ss/crappy-code';
      package: 'ConfigurationOfXenon';
      load.

((Smalltalk at:#ConfigurationOfXenon) loadDevelopment).
!

!ConfigurationOfXenon class methodsFor: 'development support' stamp: 'BernardoContreras 7/7/2012 01:07'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfXenon class methodsFor: 'private' stamp: 'BernardoContreras 7/7/2012 01:07'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfXenon class methodsFor: 'private' stamp: 'BernardoContreras 7/7/2012 01:07'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfXenon class methodsFor: 'private' stamp: 'BernardoContreras 7/7/2012 01:07'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfXenon class methodsFor: 'metacello tool support' stamp: 'BernardoContreras 7/7/2012 01:07'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfXenon class methodsFor: 'loading' stamp: 'BernardoContreras 7/7/2012 01:07'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfXenon class methodsFor: 'loading' stamp: 'BernardoContreras 7/7/2012 01:07'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfXenon class methodsFor: 'loading' stamp: 'BernardoContreras 7/7/2012 01:07'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfXenon class methodsFor: 'accessing' stamp: 'BernardoContreras 7/7/2012 01:07'!
project

	^self new project! !

!ConfigurationOfXenon class methodsFor: 'development support' stamp: 'BernardoContreras 7/7/2012 01:07'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfXenon methodsFor: 'as yet unclassified' stamp: 'BernardoContreras 7/7/2012 01:09'!
baseline01: spec
	<version: '0.1-baseline'>
	spec
		for: #pharo
		do: [ 
			spec blessing: #baseline.
			spec repository: 'http://ss3.gemstone.com/ss/crappy-code'.
			spec
				package: 'Xenon-Core';
				package: 'Curium-Core';
				package: 'Xenon-Library' with: [ spec requires: #('Xenon-Core') ];
				package: 'Xenon-Examples' with: [ spec requires: #('Curium-Core' 'Xenon-Library') ];
				package: 'Xenon-Tests' with: [ spec requires: #('Xenon-Core') ];
				package: 'Curium-Tests' with: [ spec requires: #('Curium-Core') ].
			spec
				group: 'default' with: #('Xenon-Core' 'Xenon-Tests' 'Curium-Core' 'Curium-Tests' 'Xenon-Library' 'Xenon-Examples');
				group: 'Core' with: #('Xenon-Core' 'Curium-Core');
				group: 'Examples' with: #('Xenon-Examples');
				group: 'Tests' with: #('Xenon-Tests' 'Curium-Tests') ]! !

!ConfigurationOfXenon methodsFor: 'accessing' stamp: 'BernardoContreras 7/7/2012 01:07'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfXenon methodsFor: 'as yet unclassified' stamp: 'BernardoContreras 7/7/2012 01:09'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline')>
	spec
		for: #pharo
		do: [ 
			spec blessing: #development.
			spec description: 'initial version'.
			spec author: 'BernardoContreras'.
			spec timestamp: '2/26/2012 23:06'.
			spec
				package: 'Xenon-Core' with: 'Xenon-Core';
				package: 'Curium-Core' with: 'Curium-Core';
				package: 'Xenon-Library' with: 'Xenon-Library';
				package: 'Xenon-Examples' with: 'Xenon-Examples';
				package: 'Xenon-Tests' with: 'Xenon-Tests';
				package: 'Curium-Tests' with: 'Curium-Tests' ]! !
